var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { r as registerInstance, c as createEvent, h } from './core-b620d2ff.js';
/* tslint:disable:no-bitwise */
var Base64 = /** @class */ (function () {
    function Base64() {
    }
    // base64 is 4/3 + up to two characters of the original data
    Base64.byteLength = function (b64) {
        var _a = Base64._getLengths(b64), validLength = _a[0], placeHoldersLength = _a[1];
        return Base64._byteLength(validLength, placeHoldersLength);
    };
    Base64.decode = function (b64) {
        Base64._initRevLookup();
        var _a = Base64._getLengths(b64), validLength = _a[0], placeHoldersLength = _a[1];
        var arr = new Uint8Array(Base64._byteLength(validLength, placeHoldersLength));
        var curByte = 0;
        // if there are placeholders, only get up to the last complete 4 chars
        var len = placeHoldersLength > 0 ? validLength - 4 : validLength;
        var i = 0;
        for (; i < len; i += 4) {
            var tmp = (Base64._revLookup[b64.charCodeAt(i)] << 18) |
                (Base64._revLookup[b64.charCodeAt(i + 1)] << 12) |
                (Base64._revLookup[b64.charCodeAt(i + 2)] << 6) |
                Base64._revLookup[b64.charCodeAt(i + 3)];
            arr[curByte++] = (tmp >> 16) & 0xFF;
            arr[curByte++] = (tmp >> 8) & 0xFF;
            arr[curByte++] = tmp & 0xFF;
        }
        if (placeHoldersLength === 2) {
            var tmp = (Base64._revLookup[b64.charCodeAt(i)] << 2) |
                (Base64._revLookup[b64.charCodeAt(i + 1)] >> 4);
            arr[curByte++] = tmp & 0xFF;
        }
        if (placeHoldersLength === 1) {
            var tmp = (Base64._revLookup[b64.charCodeAt(i)] << 10) |
                (Base64._revLookup[b64.charCodeAt(i + 1)] << 4) |
                (Base64._revLookup[b64.charCodeAt(i + 2)] >> 2);
            arr[curByte++] = (tmp >> 8) & 0xFF;
            arr[curByte /*++ not needed*/] = tmp & 0xFF;
        }
        return arr;
    };
    Base64.encode = function (uint8) {
        var length = uint8.length;
        var extraBytes = length % 3; // if we have 1 byte left, pad 2 bytes
        var parts = [];
        var maxChunkLength = 16383; // must be multiple of 3
        // go through the array every three bytes, we'll deal with trailing stuff later
        for (var i = 0, len2 = length - extraBytes; i < len2; i += maxChunkLength) {
            parts.push(Base64._encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
        }
        // pad the end with zeros, but make sure to not forget the extra bytes
        if (extraBytes === 1) {
            var tmp = uint8[length - 1];
            parts.push(Base64._lookup[tmp >> 2] +
                Base64._lookup[(tmp << 4) & 0x3F] +
                '==');
        }
        else if (extraBytes === 2) {
            var tmp = (uint8[length - 2] << 8) + uint8[length - 1];
            parts.push(Base64._lookup[tmp >> 10] +
                Base64._lookup[(tmp >> 4) & 0x3F] +
                Base64._lookup[(tmp << 2) & 0x3F] +
                '=');
        }
        return parts.join('');
    };
    Base64.encodeUrl = function (buffer) {
        return Base64.encode(buffer).replace(/\//g, '_').replace(/\+/g, '-').replace(/=/g, '.');
    };
    Base64.decodeUrl = function (base64) {
        return Base64.decode(base64.replace(/_/g, '/').replace(/-/g, '+').replace(/\./g, '='));
    };
    Base64._initRevLookup = function () {
        if (Base64._revLookup.length !== 0)
            return;
        Base64._revLookup = [];
        for (var i = 0, len = Base64._lookup.length; i < len; i++) {
            Base64._revLookup[Base64._lookup.charCodeAt(i)] = i;
        }
        // Support decoding URL-safe base64 strings, as Node.js does.
        // See: https://en.wikipedia.org/wiki/Base64#URL_applications
        Base64._revLookup['-'.charCodeAt(0)] = 62;
        Base64._revLookup['_'.charCodeAt(0)] = 63;
    };
    Base64._getLengths = function (b64) {
        var length = b64.length;
        if (length % 4 > 0) {
            throw new Error('Invalid string. Length must be a multiple of 4');
        }
        // Trim off extra bytes after placeholder bytes are found
        // See: https://github.com/beatgammit/base64-js/issues/42
        var validLength = b64.indexOf('=');
        if (validLength === -1)
            validLength = length;
        var placeHoldersLength = validLength === length ? 0 : 4 - (validLength % 4);
        return [validLength, placeHoldersLength];
    };
    Base64._byteLength = function (validLength, placeHoldersLength) {
        return ((validLength + placeHoldersLength) * 3 / 4) - placeHoldersLength;
    };
    Base64._tripletToBase64 = function (num) {
        return Base64._lookup[num >> 18 & 0x3F] +
            Base64._lookup[num >> 12 & 0x3F] +
            Base64._lookup[num >> 6 & 0x3F] +
            Base64._lookup[num & 0x3F];
    };
    Base64._encodeChunk = function (uint8, start, end) {
        var output = [];
        for (var i = start; i < end; i += 3) {
            var tmp = ((uint8[i] << 16) & 0xFF0000) +
                ((uint8[i + 1] << 8) & 0xFF00) +
                (uint8[i + 2] & 0xFF);
            output.push(Base64._tripletToBase64(tmp));
        }
        return output.join('');
    };
    return Base64;
}());
Base64._lookup = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
Base64._revLookup = [];
var ExtraJSONTypes;
(function (ExtraJSONTypes) {
    ExtraJSONTypes[ExtraJSONTypes["UINT8_ARRAY"] = 0] = "UINT8_ARRAY";
})(ExtraJSONTypes || (ExtraJSONTypes = {}));
var JSONUtils = /** @class */ (function () {
    function JSONUtils() {
    }
    JSONUtils.stringify = function (value) {
        return JSON.stringify(value, JSONUtils._jsonifyType);
    };
    JSONUtils.parse = function (value) {
        return JSON.parse(value, JSONUtils._parseType);
    };
    JSONUtils._parseType = function (key, value) {
        if (value && value.hasOwnProperty &&
            value.hasOwnProperty(JSONUtils.TYPE_SYMBOL) && value.hasOwnProperty(JSONUtils.VALUE_SYMBOL)) {
            switch (value[JSONUtils.TYPE_SYMBOL]) {
                case ExtraJSONTypes.UINT8_ARRAY:
                    return Base64.decode(value[JSONUtils.VALUE_SYMBOL]);
            }
        }
        return value;
    };
    JSONUtils._jsonifyType = function (key, value) {
        if (value instanceof Uint8Array) {
            return JSONUtils._typedObject(ExtraJSONTypes.UINT8_ARRAY, Base64.encode(value));
        }
        return value;
    };
    JSONUtils._typedObject = function (type, value) {
        var obj = {};
        obj[JSONUtils.TYPE_SYMBOL] = type;
        obj[JSONUtils.VALUE_SYMBOL] = value;
        return obj;
    };
    return JSONUtils;
}());
JSONUtils.TYPE_SYMBOL = '__';
JSONUtils.VALUE_SYMBOL = 'v';
var RandomUtils = /** @class */ (function () {
    function RandomUtils() {
    }
    RandomUtils.generateRandomId = function () {
        var array = new Uint32Array(1);
        crypto.getRandomValues(array);
        return array[0];
    };
    return RandomUtils;
}());
var ResponseStatus;
(function (ResponseStatus) {
    ResponseStatus["OK"] = "ok";
    ResponseStatus["ERROR"] = "error";
})(ResponseStatus || (ResponseStatus = {}));
var POSTMESSAGE_RETURN_URL = '<postMessage>';
var RequestIdStorage = /** @class */ (function () {
    /**
     * @param storeState Whether to store state in sessionStorage
     */
    function RequestIdStorage(storeState) {
        if (storeState === void 0) { storeState = true; }
        this._store = storeState ? window.sessionStorage : null;
        this._validIds = new Map();
        if (storeState) {
            this._restoreIds();
        }
    }
    RequestIdStorage._decodeIds = function (ids) {
        var obj = JSONUtils.parse(ids);
        var validIds = new Map();
        for (var _i = 0, _a = Object.keys(obj); _i < _a.length; _i++) {
            var key = _a[_i];
            var integerKey = parseInt(key, 10);
            validIds.set(isNaN(integerKey) ? key : integerKey, obj[key]);
        }
        return validIds;
    };
    RequestIdStorage.prototype.has = function (id) {
        return this._validIds.has(id);
    };
    RequestIdStorage.prototype.getCommand = function (id) {
        var result = this._validIds.get(id);
        return result ? result[0] : null;
    };
    RequestIdStorage.prototype.getState = function (id) {
        var result = this._validIds.get(id);
        return result ? result[1] : null;
    };
    RequestIdStorage.prototype.add = function (id, command, state) {
        if (state === void 0) { state = null; }
        this._validIds.set(id, [command, state]);
        this._storeIds();
    };
    RequestIdStorage.prototype.remove = function (id) {
        this._validIds.delete(id);
        this._storeIds();
    };
    RequestIdStorage.prototype.clear = function () {
        this._validIds.clear();
        if (this._store) {
            this._store.removeItem(RequestIdStorage.KEY);
        }
    };
    RequestIdStorage.prototype._encodeIds = function () {
        var obj = Object.create(null);
        for (var _i = 0, _a = this._validIds; _i < _a.length; _i++) {
            var _b = _a[_i], key = _b[0], value = _b[1];
            obj[key] = value;
        }
        return JSONUtils.stringify(obj);
    };
    RequestIdStorage.prototype._restoreIds = function () {
        var requests = this._store.getItem(RequestIdStorage.KEY);
        if (requests) {
            this._validIds = RequestIdStorage._decodeIds(requests);
        }
    };
    RequestIdStorage.prototype._storeIds = function () {
        if (this._store) {
            this._store.setItem(RequestIdStorage.KEY, this._encodeIds());
        }
    };
    return RequestIdStorage;
}());
RequestIdStorage.KEY = 'rpcRequests';
var UrlRpcEncoder = /** @class */ (function () {
    function UrlRpcEncoder() {
    }
    UrlRpcEncoder.receiveRedirectCommand = function (location) {
        var url = new URL(location.href);
        // Need referrer for origin check
        if (!document.referrer)
            return null;
        var referrer = new URL(document.referrer);
        // Parse query
        var params = new URLSearchParams(url.search);
        var fragment = new URLSearchParams(url.hash.substring(1));
        // Ignore messages without an ID
        if (!fragment.has('id'))
            return null;
        var id = parseInt(fragment.get('id'), 10);
        fragment.delete('id');
        params.set(UrlRpcEncoder.URL_SEARCHPARAM_NAME, id.toString());
        // Ignore messages without a command
        if (!fragment.has('command'))
            return null;
        var command = fragment.get('command');
        fragment.delete('command');
        // Ignore messages without a valid return path
        if (!fragment.has('returnURL'))
            return null;
        var returnURL = fragment.get('returnURL');
        fragment.delete('returnURL');
        var answerByPostMessage = returnURL === POSTMESSAGE_RETURN_URL
            && (window.opener || window.parent);
        // Only allow returning to same origin
        if (!answerByPostMessage && new URL(returnURL).origin !== referrer.origin)
            return null;
        // Parse args
        var args = [];
        if (fragment.has('args')) {
            try {
                args = JSONUtils.parse(fragment.get('args'));
            }
            catch (e) {
                // Do nothing
            }
        }
        args = Array.isArray(args) ? args : [];
        fragment.delete('args');
        url.search = params.toString();
        this._setUrlFragment(url, fragment);
        history.replaceState(history.state, '', url.href);
        return {
            origin: referrer.origin,
            data: {
                id: id,
                command: command,
                args: args,
            },
            returnURL: returnURL,
            source: answerByPostMessage ? (window.opener || window.parent) : null,
        };
    };
    UrlRpcEncoder.receiveRedirectResponse = function (location) {
        var url = new URL(location.href);
        // Need referrer for origin check
        if (!document.referrer)
            return null;
        var referrer = new URL(document.referrer);
        // Parse query
        var params = new URLSearchParams(url.search);
        var fragment = new URLSearchParams(url.hash.substring(1));
        // Ignore messages without an ID
        if (!fragment.has('id'))
            return null;
        var id = parseInt(fragment.get('id'), 10);
        fragment.delete('id');
        params.set(UrlRpcEncoder.URL_SEARCHPARAM_NAME, id.toString());
        // Ignore messages without a status
        if (!fragment.has('status'))
            return null;
        var status = fragment.get('status') === ResponseStatus.OK ? ResponseStatus.OK : ResponseStatus.ERROR;
        fragment.delete('status');
        // Ignore messages without a result
        if (!fragment.has('result'))
            return null;
        var result = JSONUtils.parse(fragment.get('result'));
        fragment.delete('result');
        url.search = params.toString();
        this._setUrlFragment(url, fragment);
        history.replaceState(history.state, '', url.href);
        return {
            origin: referrer.origin,
            data: {
                id: id,
                status: status,
                result: result,
            },
        };
    };
    UrlRpcEncoder.prepareRedirectReply = function (state, status, result) {
        var returnUrl = new URL(state.returnURL);
        var fragment = new URLSearchParams(returnUrl.hash.substring(1));
        fragment.set('id', state.id.toString());
        fragment.set('status', status);
        fragment.set('result', JSONUtils.stringify(result));
        returnUrl.hash = fragment.toString();
        return returnUrl.href;
    };
    UrlRpcEncoder.prepareRedirectInvocation = function (targetURL, id, returnURL, command, args) {
        var targetUrl = new URL(targetURL);
        var fragment = new URLSearchParams(targetUrl.hash.substring(1));
        fragment.set('id', id.toString());
        fragment.set('returnURL', returnURL);
        fragment.set('command', command);
        if (Array.isArray(args)) {
            fragment.set('args', JSONUtils.stringify(args));
        }
        targetUrl.hash = fragment.toString();
        return targetUrl.href;
    };
    UrlRpcEncoder._setUrlFragment = function (url, fragment) {
        /*
        The Url might include a fragment on its own before adding the parameters to it.
        It might even have a fragment consisting of other parameters.
        A '=' at the last position of the remaining fragment string indicates that at least one fragment
        part is remaining. Since URLSearchParams will try to represent a key=value pair with the value
        missing the '=' is added.
        Unfortunately fragments (as in regular fragment, not parameters) ending in a '=' will not
        work with this implementation. All other fragments, including other sets of parameters should be
        preserved by removing the '=' in case it exists at the end of the fragment. However, if other
        parameters are used without values (i.e. #abc&123&value) they will now include a '=' except
        for the last one (i.e. #abc=&123=&value), which is a valid input to URLSearchParams.
        */
        if (fragment.toString().endsWith('=')) {
            url.hash = fragment.toString().slice(0, -1);
        }
        else {
            url.hash = fragment.toString();
        }
    };
    return UrlRpcEncoder;
}());
UrlRpcEncoder.URL_SEARCHPARAM_NAME = 'rpcId';
var RpcClient = /** @class */ (function () {
    function RpcClient(allowedOrigin, storeState) {
        if (storeState === void 0) { storeState = false; }
        this._allowedOrigin = allowedOrigin;
        this._waitingRequests = new RequestIdStorage(storeState);
        this._responseHandlers = new Map();
        this._preserveRequests = false;
    }
    RpcClient.prototype.onResponse = function (command, resolve, reject) {
        this._responseHandlers.set(command, { resolve: resolve, reject: reject });
    };
    RpcClient.prototype._receive = function (message) {
        // Discard all messages from unwanted sources
        // or which are not replies
        // or which are not from the correct origin
        if (!message.data
            || !message.data.status
            || !message.data.id
            || (this._allowedOrigin !== '*' && message.origin !== this._allowedOrigin))
            return false;
        var data = message.data;
        var callback = this._getCallback(data.id);
        var state = this._waitingRequests.getState(data.id);
        if (callback) {
            if (!this._preserveRequests) {
                this._waitingRequests.remove(data.id);
                this._responseHandlers.delete(data.id);
            }
            console.debug('RpcClient RECEIVE', data);
            if (data.status === ResponseStatus.OK) {
                callback.resolve(data.result, data.id, state);
            }
            else if (data.status === ResponseStatus.ERROR) {
                var error = new Error(data.result.message);
                if (data.result.stack) {
                    error.stack = data.result.stack;
                }
                if (data.result.name) {
                    error.name = data.result.name;
                }
                callback.reject(error, data.id, state);
            }
            return true;
        }
        else {
            console.warn('Unknown RPC response:', data);
            return false;
        }
    };
    RpcClient.prototype._getCallback = function (id) {
        // Response handlers by id have priority to more general ones by command
        if (this._responseHandlers.has(id)) {
            return this._responseHandlers.get(id);
        }
        else {
            var command = this._waitingRequests.getCommand(id);
            if (command) {
                return this._responseHandlers.get(command);
            }
        }
        return undefined;
    };
    return RpcClient;
}());
var PostMessageRpcClient = /** @class */ (function (_super) {
    __extends(PostMessageRpcClient, _super);
    function PostMessageRpcClient(targetWindow, allowedOrigin) {
        var _this = _super.call(this, allowedOrigin) || this;
        _this._serverCloseCheckInterval = -1;
        _this._target = targetWindow;
        _this._connectionState = 0 /* DISCONNECTED */;
        _this._receiveListener = _this._receive.bind(_this);
        return _this;
    }
    PostMessageRpcClient.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._connectionState === 2 /* CONNECTED */) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this._connect()];
                    case 1:
                        _a.sent();
                        window.addEventListener('message', this._receiveListener);
                        if (this._serverCloseCheckInterval !== -1)
                            return [2 /*return*/];
                        this._serverCloseCheckInterval = window.setInterval(function () { return _this._checkIfServerClosed(); }, 300);
                        return [2 /*return*/];
                }
            });
        });
    };
    PostMessageRpcClient.prototype.call = function (command) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._call({
                        command: command,
                        args: args,
                        id: RandomUtils.generateRandomId(),
                    })];
            });
        });
    };
    PostMessageRpcClient.prototype.close = function () {
        // Clean up old requests and disconnect. Note that until the popup get's closed by the user
        // it's possible to connect again though by calling init.
        this._connectionState = 0 /* DISCONNECTED */;
        window.removeEventListener('message', this._receiveListener);
        window.clearInterval(this._serverCloseCheckInterval);
        this._serverCloseCheckInterval = -1;
        for (var _i = 0, _a = this._responseHandlers; _i < _a.length; _i++) {
            var _b = _a[_i], id = _b[0], reject = _b[1].reject;
            var state = this._waitingRequests.getState(id);
            reject('Connection was closed', typeof id === 'number' ? id : undefined, state);
        }
        this._waitingRequests.clear();
        this._responseHandlers.clear();
        if (this._target && this._target.closed)
            this._target = null;
    };
    PostMessageRpcClient.prototype._receive = function (message) {
        if (message.source !== this._target) {
            // ignore messages originating from another client's target window
            return false;
        }
        return _super.prototype._receive.call(this, message);
    };
    PostMessageRpcClient.prototype._call = function (request) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (!this._target || this._target.closed) {
                    throw new Error('Connection was closed.');
                }
                if (this._connectionState !== 2 /* CONNECTED */) {
                    throw new Error('Client is not connected, call init first');
                }
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        // Store the request resolvers
                        _this._responseHandlers.set(request.id, { resolve: resolve, reject: reject });
                        _this._waitingRequests.add(request.id, request.command);
                        console.debug('RpcClient REQUEST', request.command, request.args);
                        _this._target.postMessage(request, _this._allowedOrigin);
                    })];
            });
        });
    };
    PostMessageRpcClient.prototype._connect = function () {
        var _this = this;
        if (this._connectionState === 2 /* CONNECTED */)
            return;
        this._connectionState = 1 /* CONNECTING */;
        return new Promise(function (resolve, reject) {
            var connectedListener = function (message) {
                var source = message.source, origin = message.origin, data = message.data;
                if (source !== _this._target
                    || data.status !== ResponseStatus.OK
                    || data.result !== 'pong'
                    || data.id !== 1
                    || (_this._allowedOrigin !== '*' && origin !== _this._allowedOrigin))
                    return;
                // Debugging printouts
                if (data.result.stack) {
                    var error = new Error(data.result.message);
                    error.stack = data.result.stack;
                    if (data.result.name) {
                        error.name = data.result.name;
                    }
                    console.error(error);
                }
                window.removeEventListener('message', connectedListener);
                _this._connectionState = 2 /* CONNECTED */;
                console.log('RpcClient: Connection established');
                resolve(true);
            };
            window.addEventListener('message', connectedListener);
            /**
             * Send 'ping' command every 100ms, until cancelled
             */
            var tryToConnect = function () {
                if (_this._connectionState === 2 /* CONNECTED */)
                    return;
                if (_this._connectionState === 0 /* DISCONNECTED */
                    || _this._checkIfServerClosed()) {
                    window.removeEventListener('message', connectedListener);
                    reject(new Error('Connection was closed'));
                    return;
                }
                try {
                    _this._target.postMessage({ command: 'ping', id: 1 }, _this._allowedOrigin);
                }
                catch (e) {
                    console.error("postMessage failed: " + e);
                }
                window.setTimeout(tryToConnect, 100);
            };
            window.setTimeout(tryToConnect, 100);
        });
    };
    PostMessageRpcClient.prototype._checkIfServerClosed = function () {
        if (this._target && !this._target.closed)
            return false;
        this.close();
        return true;
    };
    return PostMessageRpcClient;
}(RpcClient));
var RedirectRpcClient = /** @class */ (function (_super) {
    __extends(RedirectRpcClient, _super);
    function RedirectRpcClient(targetURL, allowedOrigin, preserveRequests) {
        if (preserveRequests === void 0) { preserveRequests = true; }
        var _this = _super.call(this, allowedOrigin, /*storeState*/ true) || this;
        _this._target = targetURL;
        _this._preserveRequests = preserveRequests;
        return _this;
    }
    RedirectRpcClient.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var urlResponse, searchParams, storedResponse;
            return __generator(this, function (_a) {
                urlResponse = UrlRpcEncoder.receiveRedirectResponse(window.location);
                if (urlResponse) {
                    this._receive(urlResponse);
                    return [2 /*return*/];
                }
                // If there was no response in the URL it might be a history.back.
                if (this._rejectOnBack())
                    return [2 /*return*/]; // if rejectOnBack did reject do not look for a stored response
                searchParams = new URLSearchParams(window.location.search);
                if (searchParams.has(UrlRpcEncoder.URL_SEARCHPARAM_NAME)) {
                    storedResponse = window.sessionStorage.getItem("response-" + searchParams.get(UrlRpcEncoder.URL_SEARCHPARAM_NAME));
                    if (storedResponse) {
                        this._receive(JSONUtils.parse(storedResponse), false);
                        return [2 /*return*/];
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    /* tslint:disable-next-line:no-empty */
    RedirectRpcClient.prototype.close = function () { };
    RedirectRpcClient.prototype.call = function (returnURL, command, handleHistoryBack) {
        if (handleHistoryBack === void 0) { handleHistoryBack = false; }
        var args = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            args[_i - 3] = arguments[_i];
        }
        this.callAndSaveLocalState.apply(this, __spreadArrays([returnURL, null, command, handleHistoryBack], args));
    };
    RedirectRpcClient.prototype.callAndSaveLocalState = function (returnURL, state, command, handleHistoryBack) {
        if (handleHistoryBack === void 0) { handleHistoryBack = false; }
        var args = [];
        for (var _i = 4; _i < arguments.length; _i++) {
            args[_i - 4] = arguments[_i];
        }
        var id = RandomUtils.generateRandomId();
        var url = UrlRpcEncoder.prepareRedirectInvocation(this._target, id, returnURL, command, args);
        this._waitingRequests.add(id, command, state);
        if (handleHistoryBack) {
            /**
             * The rpcBackRejectionId in the history.state is used to detect in the client
             * if a history entry was visited before, which makes it a history.back
             * navigation. The stored ID is then also used to retrieve the correct
             * stored callback and waiting request, to be able to reject it.
             */
            history.replaceState(Object.assign({}, history.state, { rpcBackRejectionId: id }), '');
        }
        console.debug('RpcClient REQUEST', command, args);
        window.location.href = url;
    };
    RedirectRpcClient.prototype._receive = function (response, persistMessage) {
        if (persistMessage === void 0) { persistMessage = true; }
        var responseWasHandled = _super.prototype._receive.call(this, response);
        if (responseWasHandled && persistMessage) {
            window.sessionStorage.setItem("response-" + response.data.id, JSONUtils.stringify(response));
        }
        return responseWasHandled;
    };
    RedirectRpcClient.prototype._rejectOnBack = function () {
        if (!history.state || !history.state.rpcBackRejectionId)
            return false;
        var id = history.state.rpcBackRejectionId;
        // Delete the ID, so the request is not rejected again when the page is refreshed/revisited
        history.replaceState(Object.assign({}, history.state, { rpcBackRejectionId: null }), '');
        var callback = this._getCallback(id);
        var state = this._waitingRequests.getState(id);
        if (callback) {
            if (!this._preserveRequests) {
                this._waitingRequests.remove(id);
                this._responseHandlers.delete(id);
            }
            console.debug('RpcClient BACK');
            var error = new Error('Request aborted');
            callback.reject(error, id, state);
            return true;
        }
        return false;
    };
    return RedirectRpcClient;
}(RpcClient));
var RequestBehavior = /** @class */ (function () {
    function RequestBehavior(type) {
        this._type = type;
    }
    RequestBehavior.getAllowedOrigin = function (endpoint) {
        var url = new URL(endpoint);
        return url.origin;
    };
    RequestBehavior.prototype.request = function (endpoint, command, args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new Error('Not implemented');
            });
        });
    };
    return RequestBehavior;
}());
var BehaviorType;
(function (BehaviorType) {
    BehaviorType[BehaviorType["REDIRECT"] = 0] = "REDIRECT";
    BehaviorType[BehaviorType["POPUP"] = 1] = "POPUP";
    BehaviorType[BehaviorType["IFRAME"] = 2] = "IFRAME";
})(BehaviorType || (BehaviorType = {}));
var RedirectRequestBehavior = /** @class */ (function (_super) {
    __extends(RedirectRequestBehavior, _super);
    function RedirectRequestBehavior(returnUrl, localState) {
        var _this = _super.call(this, BehaviorType.REDIRECT) || this;
        var location = window.location;
        _this._returnUrl = returnUrl || "" + location.origin + location.pathname;
        _this._localState = localState || {};
        // Reject local state with reserved property.
        if (typeof _this._localState.__command !== 'undefined') {
            throw new Error('Invalid localState: Property \'__command\' is reserved');
        }
        return _this;
    }
    RedirectRequestBehavior.withLocalState = function (localState) {
        return new RedirectRequestBehavior(undefined, localState);
    };
    RedirectRequestBehavior.prototype.request = function (endpoint, command, args) {
        return __awaiter(this, void 0, void 0, function () {
            var origin, client, state;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        origin = RequestBehavior.getAllowedOrigin(endpoint);
                        client = new RedirectRpcClient(endpoint, origin);
                        return [4 /*yield*/, client.init()];
                    case 1:
                        _a.sent();
                        state = Object.assign({}, this._localState, { __command: command });
                        client.callAndSaveLocalState.apply(client, __spreadArrays([this._returnUrl, state, command, true], args));
                        return [2 /*return*/];
                }
            });
        });
    };
    return RedirectRequestBehavior;
}(RequestBehavior));
var PopupRequestBehavior = /** @class */ (function (_super) {
    __extends(PopupRequestBehavior, _super);
    function PopupRequestBehavior(options) {
        if (options === void 0) { options = PopupRequestBehavior.DEFAULT_OPTIONS; }
        var _this = _super.call(this, BehaviorType.POPUP) || this;
        _this._options = options;
        return _this;
    }
    PopupRequestBehavior.prototype.request = function (endpoint, command, args) {
        return __awaiter(this, void 0, void 0, function () {
            var origin, popup, client, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        origin = RequestBehavior.getAllowedOrigin(endpoint);
                        popup = this.createPopup(endpoint);
                        client = new PostMessageRpcClient(popup, origin);
                        return [4 /*yield*/, client.init()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, 5, 6]);
                        return [4 /*yield*/, client.call.apply(client, __spreadArrays([command], args))];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4:
                        e_1 = _a.sent();
                        throw e_1;
                    case 5:
                        client.close();
                        popup.close();
                        return [7 /*endfinally*/];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    PopupRequestBehavior.prototype.createPopup = function (url) {
        var popup = window.open(url, 'NimiqAccounts', this._options);
        if (!popup) {
            throw new Error('Failed to open popup');
        }
        return popup;
    };
    return PopupRequestBehavior;
}(RequestBehavior));
PopupRequestBehavior.DEFAULT_OPTIONS = '';
var IFrameRequestBehavior = /** @class */ (function (_super) {
    __extends(IFrameRequestBehavior, _super);
    function IFrameRequestBehavior() {
        var _this = _super.call(this, BehaviorType.IFRAME) || this;
        _this._iframe = null;
        _this._client = null;
        return _this;
    }
    IFrameRequestBehavior.prototype.request = function (endpoint, command, args) {
        return __awaiter(this, void 0, void 0, function () {
            var origin, _a;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (this._iframe && this._iframe.src !== "" + endpoint + IFrameRequestBehavior.IFRAME_PATH_SUFFIX) {
                            throw new Error('Hub iframe is already opened with another endpoint');
                        }
                        origin = RequestBehavior.getAllowedOrigin(endpoint);
                        if (!!this._iframe) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, this.createIFrame(endpoint)];
                    case 1:
                        _a._iframe = _c.sent();
                        _c.label = 2;
                    case 2:
                        if (!this._iframe.contentWindow) {
                            throw new Error("IFrame contentWindow is " + typeof this._iframe.contentWindow);
                        }
                        if (!!this._client) return [3 /*break*/, 4];
                        this._client = new PostMessageRpcClient(this._iframe.contentWindow, origin);
                        return [4 /*yield*/, this._client.init()];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4: return [4 /*yield*/, (_b = this._client).call.apply(_b, __spreadArrays([command], args))];
                    case 5: return [2 /*return*/, _c.sent()];
                }
            });
        });
    };
    IFrameRequestBehavior.prototype.createIFrame = function (endpoint) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var $iframe = document.createElement('iframe');
                        $iframe.name = 'NimiqAccountsIFrame';
                        $iframe.style.display = 'none';
                        document.body.appendChild($iframe);
                        $iframe.src = "" + endpoint + IFrameRequestBehavior.IFRAME_PATH_SUFFIX;
                        $iframe.onload = function () { return resolve($iframe); };
                        $iframe.onerror = reject;
                    })];
            });
        });
    };
    return IFrameRequestBehavior;
}(RequestBehavior));
IFrameRequestBehavior.IFRAME_PATH_SUFFIX = '/iframe.html';
var RequestType;
(function (RequestType) {
    RequestType["LIST"] = "list";
    RequestType["MIGRATE"] = "migrate";
    RequestType["CHECKOUT"] = "checkout";
    RequestType["SIGN_MESSAGE"] = "sign-message";
    RequestType["SIGN_TRANSACTION"] = "sign-transaction";
    RequestType["ONBOARD"] = "onboard";
    RequestType["SIGNUP"] = "signup";
    RequestType["LOGIN"] = "login";
    RequestType["EXPORT"] = "export";
    RequestType["CHANGE_PASSWORD"] = "change-password";
    RequestType["LOGOUT"] = "logout";
    RequestType["ADD_ADDRESS"] = "add-address";
    RequestType["RENAME"] = "rename";
    RequestType["CHOOSE_ADDRESS"] = "choose-address";
})(RequestType || (RequestType = {}));
var HubApi = /** @class */ (function () {
    function HubApi(endpoint, defaultBehavior) {
        if (endpoint === void 0) { endpoint = HubApi.DEFAULT_ENDPOINT; }
        this._endpoint = endpoint;
        this._defaultBehavior = defaultBehavior || new PopupRequestBehavior("left=" + (window.innerWidth / 2 - 400) + ",top=75,width=800,height=850,location=yes,dependent=yes");
        this._iframeBehavior = new IFrameRequestBehavior();
        // Check for RPC results in the URL
        this._redirectClient = new RedirectRpcClient('', RequestBehavior.getAllowedOrigin(this._endpoint));
    }
    Object.defineProperty(HubApi, "DEFAULT_ENDPOINT", {
        get: function () {
            var originArray = location.origin.split('.');
            originArray.shift();
            var tld = originArray.join('.');
            switch (tld) {
                case 'nimiq.com':
                    return 'https://hub.nimiq.com';
                case 'nimiq-testnet.com':
                    return 'https://hub.nimiq-testnet.com';
                default:
                    return 'http://localhost:8080';
            }
        },
        enumerable: true,
        configurable: true
    });
    HubApi.prototype.checkRedirectResponse = function () {
        return this._redirectClient.init();
    };
    HubApi.prototype.on = function (command, resolve, reject) {
        this._redirectClient.onResponse(command, 
        // State is always an object containing at least the __command property
        function (result, rpcId, state) { return resolve(result, state); }, function (error, rpcId, state) {
            if (!reject)
                return;
            reject(error, state);
        });
    };
    /**
     * Public API
     */
    HubApi.prototype.checkout = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.CHECKOUT, [request]);
    };
    HubApi.prototype.chooseAddress = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.CHOOSE_ADDRESS, [request]);
    };
    HubApi.prototype.signTransaction = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.SIGN_TRANSACTION, [request]);
    };
    HubApi.prototype.signMessage = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.SIGN_MESSAGE, [request]);
    };
    /**
     * Account Management
     *
     * Only accessible from Nimiq domains.
     */
    HubApi.prototype.onboard = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.ONBOARD, [request]);
    };
    HubApi.prototype.signup = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.SIGNUP, [request]);
    };
    HubApi.prototype.login = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.LOGIN, [request]);
    };
    HubApi.prototype.logout = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.LOGOUT, [request]);
    };
    HubApi.prototype.export = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.EXPORT, [request]);
    };
    HubApi.prototype.changePassword = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.CHANGE_PASSWORD, [request]);
    };
    HubApi.prototype.addAddress = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.ADD_ADDRESS, [request]);
    };
    HubApi.prototype.rename = function (request, requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.RENAME, [request]);
    };
    HubApi.prototype.migrate = function (requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._defaultBehavior; }
        return this._request(requestBehavior, RequestType.MIGRATE, [{ appName: 'Account list' }]);
    };
    /**
     * Only accessible in iframe from Nimiq domains.
     */
    HubApi.prototype.list = function (requestBehavior) {
        if (requestBehavior === void 0) { requestBehavior = this._iframeBehavior; }
        return this._request(requestBehavior, RequestType.LIST, []);
    };
    // END API
    /* PRIVATE METHODS */
    HubApi.prototype._request = function (behavior, command, args) {
        return behavior.request(this._endpoint, command, args);
    };
    return HubApi;
}());
HubApi.RequestType = RequestType;
HubApi.RedirectRequestBehavior = RedirectRequestBehavior;
HubApi.MSG_PREFIX = '\x16Nimiq Signed Message:\n';
var HubUrl = {
    main: 'https://hub.nimiq.com',
    test: 'https://hub.nimiq-testnet.com',
};
var Checkout = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.inProgress = false;
        /**
         * The theme of the button. Use light when using against dark background.
         */
        this.theme = 'dark';
        /**
         * The network you want to use. Can be 'main' or 'test'.
         */
        this.network = 'main';
        this.nimCheckoutSuccess = createEvent(this, "nimCheckoutSuccess", 7);
        this.nimCheckoutError = createEvent(this, "nimCheckoutError", 7);
    }
    class_1.prototype.checkout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var options, hubApi, transaction, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.inProgress = true;
                        options = {
                            appName: this.app,
                            recipient: this.recipient,
                            value: this.value,
                        };
                        if (this.logoUrl) {
                            options.shopLogoUrl = this.logoUrl;
                        }
                        if (this.fee) {
                            options.fee = this.fee;
                        }
                        if (this.data) {
                            options.extraData = this.data;
                        }
                        hubApi = new HubApi(HubUrl[this.network]);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, hubApi.checkout(options)];
                    case 2:
                        transaction = _a.sent();
                        this.nimCheckoutSuccess.emit(transaction);
                        this.inProgress = false;
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        this.nimCheckoutError.emit(error_1);
                        this.inProgress = false;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.renderLogo = function (color) {
        if (color === void 0) { color = true; }
        if (color) {
            return (h("svg", { class: "nim-logo", "data-name": "Layer 1", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 16 16" }, h("defs", null, h("radialGradient", { id: "a", cx: "12.02", cy: "14.85", r: "15.87", gradientUnits: "userSpaceOnUse" }, h("stop", { offset: "0", "stop-color": "#ec991c" }), h("stop", { offset: "1", "stop-color": "#e9b213" }))), h("path", { d: "M15.82 7.34l-3.33-5.68A1.34 1.34 0 0 0 11.33 1H4.67a1.34 1.34 0 0 0-1.16.66L.18 7.34a1.3 1.3 0 0 0 0 1.32l3.33 5.68a1.34 1.34 0 0 0 1.16.66h6.66a1.34 1.34 0 0 0 1.16-.66l3.33-5.68a1.3 1.3 0 0 0 0-1.32z", fill: "url(#a)" })));
        }
        else {
            return (h("svg", { class: "nim-logo", "data-name": "Layer 1", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 16 16" }, h("path", { d: "M15.82 7.34l-3.33-5.68A1.34 1.34 0 0 0 11.33 1H4.67a1.34 1.34 0 0 0-1.16.66L.18 7.34a1.3 1.3 0 0 0 0 1.32l3.33 5.68a1.34 1.34 0 0 0 1.16.66h6.66a1.34 1.34 0 0 0 1.16-.66l3.33-5.68a1.3 1.3 0 0 0 0-1.32z", fill: "#fff" })));
        }
    };
    class_1.prototype.render = function () {
        var _this = this;
        return (h("button", { class: 'nim-theme-' + this.theme, type: "button", onClick: function (_) { return _this.checkout(); } }, this.renderLogo(true), h("div", null, this.inProgress ? (h("span", null, "In progress...")) : (h("span", null, h("strong", null, "Nimiq"), " Checkout")))));
    };
    Object.defineProperty(class_1, "style", {
        get: function () { return "button{background-color:#f1f1f4;color:#1f2348;border-radius:4px;border:0 none;padding:8px 32px;margin:0;display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;font-size:16px;-webkit-transition:color .3s,background-color .3s;transition:color .3s,background-color .3s}button:hover{color:#151833;background-color:#e4e4e9;cursor:pointer}button.nim-theme-dark{color:#fff;background-color:#1f2348}button.nim-theme-dark:hover{color:#fff;background-color:#151833}.nim-logo{width:28px;height:28px;margin-right:8px}"; },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
export { Checkout as nim_checkout };
